/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "dpmsglobaldialog.h"

DPMSGlobalDialog::DPMSGlobalDialog(QWidget *parent, const char *name, QString xorgFile, QString sectionName, int sectionNumber)
    :dpmsSetupWindow(parent, name)
{
x = new xorgConf();
x->saveXorg(xorgFile);



secName = sectionName;
secNum = sectionNumber;

if (x->returnConfig().contains("BlankTime") > 0 || x->returnConfig().contains("StandbyTime") > 0 || x->returnConfig().contains("SuspendTime") > 0 || x->returnConfig().contains("OffTime") > 0)
{
bool ok;
int value;
groupBox17->setChecked(TRUE);
value = x->getOption( secName, secNum, "BlankTime").toInt( &ok, 10);
blankSpinBox->setValue(value);
value = x->getOption( secName, secNum, "StandbyTime").toInt( &ok, 10);
standbySpinBox->setValue(value);
value = x->getOption( secName, secNum, "SuspendTime").toInt( &ok, 10);
suspendSpinBox->setValue(value);
value = x->getOption( secName, secNum, "OffTime").toInt( &ok, 10);
offSpinBox->setValue(value);
}
else
{
groupBox17->setChecked(FALSE);
}

}

QString DPMSGlobalDialog :: returnXorg()
{

return x->returnConfig();
}

void DPMSGlobalDialog :: accept()
{
if (!groupBox17->isChecked())
{
x->removeOption(secName, secNum, "BlankTime");
x->removeOption(secName, secNum, "StandbyTime");
x->removeOption(secName, secNum, "SuspendTime");
x->removeOption(secName, secNum, "OffTime");
}
if (groupBox17->isChecked())
{
QString num;
num = num.setNum(blankSpinBox->value(), 10);
x->saveOption(secName, secNum, "BlankTime", 1, num);
num = num.setNum(standbySpinBox->value(), 10);
x->saveOption(secName, secNum, "StandbyTime", 1, num);
num = num.setNum(suspendSpinBox->value(), 10);
x->saveOption(secName, secNum, "SuspendTime", 1, num);
num = num.setNum(offSpinBox->value(), 10);
x->saveOption(secName, secNum, "OffTime", 1, num);
}


close();
}

void DPMSGlobalDialog :: testDPMS()
{
KProcess *proc = new KProcess;
*proc << "xset" << "dpms" << "force" << "off";
proc->start();
}

#include "dpmsglobaldialog.moc"
