/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kxmain.h"
#include "aboutdialogwindow.h"
#include "debugwindowinformation.h"

kxMain::kxMain(QWidget *parent, const char *name)
    :Form1(parent, name)
{
x = new xorgConf();
checkAll();
srvInputsPrepare();
fillVideocard();
fillMonitor();
fillModules();
fillFiles();
fillMouseKbd();
fillScreenCombos();
fillScreen();
fillServerLayout();
initCheckboxes();

}

void kxMain :: fillModules()
{
QString bb;
int a = 1;
while (a > -1)
{
bb = x->getValue("Module", 1, "Load", a);
if (bb == "") { break; }
modulesBox->insertItem(bb);
moduleComboBox->insertItem(bb);
a++;
}
modulesBox->setSelected(0, TRUE);
}

void kxMain :: fillVideocard()
{


QString toAdd = x->getValue("Device", videoSpinBox->value(), "Identifier", 1);
QString numAdd;
videoIdentEdit->setText(toAdd);
numAdd = numAdd.setNum(videoSpinBox->value(), 10);



toAdd = x->getValue("Device", videoSpinBox->value(), "Vendor", 1);
videoVendorEdit->setText(toAdd);
int a = 0;
while (a < videoComboBox->count())
{
if (videoComboBox->text(a).section(" - ", 0, 0) == x->getValue("Device", videoSpinBox->value(), "Driver", 1)) { break; }
a++;
if (a == videoComboBox->count()) { a = 65535; break; }
}
if (a < videoComboBox->count()) { 
videoComboBox->setCurrentItem(a); 
}
if (a == 65535) 
{
videoComboBox->insertItem(x->getValue("Device", videoSpinBox->value(), "Driver", 1).append(tr(" - unknown driver")));
videoComboBox->setCurrentItem(videoComboBox->count() - 1);
}

numAdd = numAdd.setNum(x->sectionCount("Device"));
videoSpinBox->setMaxValue(x->sectionCount("Device"));


QString label;
QString num;
if (x->sectionCount("Device") == 1) { label = " entry"; }
if (x->sectionCount("Device") > 1) { label = " entries"; }

num = num.setNum(x->sectionCount("Device"), 10);
label = label.prepend(num);
videoEntriesLabel->setText(label);

}

void kxMain :: fillMonitor()
{
monitorSpinBox->setMaxValue(x->sectionCount("Monitor"));
QString numAdd;
numAdd = numAdd.setNum(monitorSpinBox->value(), 10);
QString toAdd;

toAdd = x->getValue("Monitor", monitorSpinBox->value(), "Identifier", 1);
monitorIdentEdit->setText(toAdd);

toAdd = x->getValue("Monitor", monitorSpinBox->value(), "ModelName", 1);
monitorModelEdit->setText(toAdd);

toAdd = x->getValue("Monitor", monitorSpinBox->value(), "VendorName", 1);
monitorVendorEdit->setText(toAdd);



QString label;
QString num;
if (x->sectionCount("Monitor") == 1) { label = " entry"; }
if (x->sectionCount("Monitor") > 1) { label = " entries"; }

num = num.setNum(x->sectionCount("Monitor"), 10);
label = label.prepend(num);
monitorEntriesLabel->setText(label);

}

void kxMain :: fillFiles()
{

QString buf = x->getValue("Files", 1, "RgbPath", 1);
int a = 1;
int q = 1;

if (buf == "") { rgbGroupBox->setChecked(FALSE); }
if (buf != "") { rgbGroupBox->setChecked(TRUE); rgbLineEdit->setText(buf); }

QString modList = "";
QString fontsList = "";

while (a > - 1)
{
if (x->getValue("Files", 1, "FontPath", a) == "") { break; }
fontsList = fontsList.append(x->getValue("Files", 1, "FontPath", a)).append(",");
a++;
}
fontsList = fontsList.replace(",", " | ");

a = 1;
while (a > - 1)
{
if (x->getValue("Files", 1, "ModulePath", a) == "") { break; }
modList = modList.append(x->getValue("Files", 1, "ModulePath", a)).append(",");
a++;
}
modList = modList.replace(",", " | ");


if (fontsList != "")
{
fontsGroupBox->setChecked(TRUE);
a = 0;
while (a > -1)
{
if (fontsList.section(" | ", a, a) == "") { break; }
fontsBox->insertItem(fontsList.section(" | ", a, a));
a++;
}
fontsBox->setSelected(0, TRUE);
}


if (modList != "")
{
modulesPathGroupBox->setChecked(TRUE);
a = 0;
while (a > -1)
{
if (modList.section(" | ", a, a) == "") { break; }
modulesPathListBox->insertItem(modList.section(" | ", a, a));
a++;
}
modulesPathListBox->setSelected(0, TRUE);
}
}

void kxMain :: fillServerLayout()
{
listBox16->clear();
int a = 1;
while (a <= x->sectionCount("ServerLayout"))
{
listBox16->insertItem(x->getValue("ServerLayout", a, "Identifier", 1));
a++;
}
listBox16->setSelected(0, TRUE);
}

void kxMain :: checkAll()
{

}

void kxMain :: aboutDialog()
{
aboutDialogWindow *about = new aboutDialogWindow();
about->exec();
}

void kxMain :: showDebug()
{
debugWindowInformation *debug = new debugWindowInformation(this, "Debug Window", x->returnConfig());
debug->exec();
}

void kxMain :: removeDevice()
{
if (x->sectionCount("Device") == 1)
{
QMessageBox::warning(this, "kX Generator", tr("There must be at least one Device entry."));
return;
}

if (x->sectionCount("Device") > 1)
{
x->removeSection("Device", videoSpinBox->value());
fillVideocard();
fillScreenCombos();
}

}

void kxMain :: addDevice()
{
x->addSection("Device");
x->saveValue("Device", videoSpinBox->maxValue() + 1, "Driver", 1, "apm");
fillVideocard();
videoSpinBox->setValue(videoSpinBox->maxValue());
QString num;
num = num.setNum(videoSpinBox->value(), 10);
videoIdentEdit->setText("Device" + num);
fillScreenCombos();
}

void kxMain :: addMonitor()
{
x->addSection("Monitor");
fillMonitor();
monitorSpinBox->setValue(monitorSpinBox->maxValue());
QString num;
num = num.setNum(monitorSpinBox->value(), 10);
monitorIdentEdit->setText("Monitor" + num);
fillScreenCombos();

}

void kxMain :: addServerLayout()
{
x->addSection("ServerLayout");
QString layoutNumber;
layoutNumber = layoutNumber.setNum(listBox16->count(), 10);
x->saveValue("ServerLayout", x->sectionCount("ServerLayout"), "Identifier", 1, "Layout" + layoutNumber);
fillServerLayout();
listBox16->setSelected(listBox16->count() - 1, TRUE);
int a = 1;
LayoutsCombo->clear();
while (a <= x->sectionCount("ServerLayout"))
{
LayoutsCombo->insertItem(x->getValue("ServerLayout", a, "Identifier", 1));
a++;
}
}

void kxMain :: changeServerLayoutName()
{
renameSrvLayDialogWindow *rename = new renameSrvLayDialogWindow(this, "Rename Server Layout", listBox16->text(listBox16->currentItem()));
rename->exec();
if (rename->output != "NONE")
{
listBox16->changeItem(rename->output, listBox16->currentItem());
x->saveValue("ServerLayout", listBox16->currentItem() + 1, "Identifier", 1, rename->output);
}
delete rename;
}

void kxMain :: removeMonitor()
{
if (x->sectionCount("Monitor") == 1)
{
QMessageBox::warning(this, "kX Generator", tr("There must be at least one Monitor entry."));
return;
}

if (x->sectionCount("Monitor") > 1)
{
x->removeSection("Monitor", videoSpinBox->value());
fillMonitor();
fillScreenCombos();
}

}

void kxMain :: removeServerLayout()
{
if (x->sectionCount("ServerLayout") == 1)
{
QMessageBox::warning(this, "kX Generator", tr("There must be at least one ServerLayout entry."));
return;
}

if (x->sectionCount("ServerLayout") > 1)
{
int a = listBox16->currentItem();
x->removeSection("ServerLayout", a + 1);
fillServerLayout();
listBox16->setSelected(a, TRUE);
int b = 1;
LayoutsCombo->clear();

while (b <= x->sectionCount("ServerLayout"))
{
LayoutsCombo->insertItem(x->getValue("ServerLayout", b, "Identifier", 1));
b++;
}

LayoutsCombo->setCurrentItem(a - 1);
if (a == listBox16->count()) { listBox16->setSelected(a - 1, TRUE); }
LayoutsComboSave();
}


}

void kxMain :: addModuleToList()
{
int a = 0;
while (a <= modulesBox->count())
{
if (modulesBox->text(a) == moduleComboBox->text(moduleComboBox->currentItem()))
{
QMessageBox::warning(this, "kX Generator", tr("Module is already on list!"));
return;
}
a++;
}
modulesBox->insertItem(moduleComboBox->text(moduleComboBox->currentItem()));
x->addModule(moduleComboBox->text(moduleComboBox->currentItem()));
modulesBox->setSelected(modulesBox->count() - 1, TRUE);
}

void kxMain :: removeModuleFromList()
{
int a = modulesBox->currentItem();
x->removeModule(modulesBox->text(a));
modulesBox->removeItem(a);
if (a == modulesBox->count()) { modulesBox->setSelected(modulesBox->count() - 1, TRUE); }
if (a < modulesBox->count()) { modulesBox->setSelected(a, TRUE); }


}

void kxMain :: fillServerLayoutComponents()
{
listBox23->clear();
listBox23_2->clear();
listBox23_2_2->clear();
//*******
//Screens
//*******
QString screens = x->getSrvLayScreens(listBox16->currentItem() + 1);
int a = 0;
while (a > -1)
{
if (screens.section("|", a, a) == "") { break; }
listBox23->insertItem(screens.section("|", a, a).section("-", 1, 1));
a++;
}


//**********
//Mouse
//**********
QString mouse = x->getMouseList();
int b = 1;
while (b > -1)
{
a = 0;
   while (b > -1)
   {
   if (mouse.section("|", a, a) == "") { break; }
   if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == mouse.section("|", a, a))
   {
   listBox23_2->insertItem(mouse.section("|", a, a));
   break;
   }
   a++;
   }
if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == "") { break; }
b++;
}
//*********
//Keyboard
//*********
QString keyboard = x->getKeyboardList();

b = 1;
while (b > -1)
{
a = 0;
   while (b > -1)
   {
   if (keyboard.section("|", a, a) == "") { break; }
   if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == keyboard.section("|", a, a))
   {
   listBox23_2_2->insertItem(keyboard.section("|", a, a));
   break;
   }
   a++;
   }
if (x->getValue("ServerLayout", listBox16->currentItem() + 1, "InputDevice", b).section("-", 1, 1) == "") { break; }
b++;
}
listBox23->setSelected(0, TRUE);
listBox23_2->setSelected(0, TRUE);
listBox23_2_2->setSelected(0, TRUE);


if (listBox23->count() == 0) { removeSrvLayScreenButton->setEnabled(FALSE); }
if (listBox23->count() > 0) { removeSrvLayScreenButton->setEnabled(TRUE); }

if (listBox23_2->count() == 0) { removeSrvLayMouseButton->setEnabled(FALSE); }
if (listBox23_2->count() > 0) { removeSrvLayMouseButton->setEnabled(TRUE); }

if (listBox23_2_2->count() == 0) { removeSrvLayKeyboardButton->setEnabled(FALSE); }
if (listBox23_2_2->count() > 0) { removeSrvLayKeyboardButton->setEnabled(TRUE); }





}

void kxMain :: setRGBPath()
{
x->saveValue("Files", 1, "RgbPath", 1, rgbLineEdit->text());
}

void kxMain :: newRGBPath()
{
QString toEnter = KFileDialog :: getExistingDirectory (QDir::homeDirPath(), this, tr("Choose RGB path..."));
if (toEnter != "") { rgbLineEdit->setText(toEnter); }
}

void kxMain :: fillMouseKbd()
{




//**************************************
//Mouse tab
//**************************************



//Saving checkBox

//					Identifier & spin box
pointerSpinBox->setMaxValue(x->pointerCount());
mouseIdentLineEdit->setText(x->getValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Identifier", 1));
//					Driver
int a = 0;
while (a < comboBox3->count())
{
if (comboBox3->text(a).section(" - ", 0, 0) == x->getValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Driver", 1))
  {
   comboBox3->setCurrentItem(a);
   a = 32000;
   break;
  }
a++;
}
if (a != 32000)
{
comboBox3->insertItem(x->getValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Driver", 1));
comboBox3->setCurrentItem(comboBox3->count() - 1);
}


//					Device
if (x->getOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device") != "")
{
checkBox4->setChecked(FALSE);
mouseDeviceLineEdit->setText(x->getOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device"));
}

if (x->getOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device") == "")
{
checkBox4->setChecked(TRUE);
}


//****************************************
//Keyboard tab
//****************************************
kbdSpinBox->setMaxValue(x->kbdCount());
kbdIdentLineEdit->setText(x->getValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Identifier", 1));
QString getOption(QString sectionName, int sectionNumber, QString OptionName);

//Driver
a = 0;
while (a < comboBox6->count())
{
if (comboBox6->text(a).section(" - ", 0, 0) == x->getValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Driver", 1))
  {
   comboBox6->setCurrentItem(a);
   a = 32000;
   break;
  }
a++;
}
if (a != 32000)
{
comboBox6->insertItem(x->getValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Driver", 1));
comboBox6->setCurrentItem(comboBox6->count() - 1);
}


















//XKBModel

QString xkbModel = x->getOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel");
bool valExists = x->valExists("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel");
if (!valExists) { checkBox40->setChecked(TRUE); }

if (valExists) 
{
checkBox40->setChecked(FALSE);
int a = 0;
while (a < comboBox9->count())
{
if (xkbModel == comboBox9->text(a)) { comboBox9->setCurrentItem(a); a = 30000; break; }
a++;
}
if (a != 30000) { comboBox9->insertItem(xkbModel); comboBox9->setCurrentItem(comboBox9->count() - 1); }
}

//XKBLayout

QString xkbLayout = x->getOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbLayout");


a = 0;
while (a < comboBox10->count())
{
if (xkbLayout == comboBox10->text(a).section(" - ", 0, 0)) { comboBox10->setCurrentItem(a); a = 30000; break; }
a++;
}
if (a != 30000) { comboBox10->setCurrentItem(0); }



//Labels
QString pointerNum = "";
QString kbdNum = "";

if (x->pointerCount() == 1) { textLabel3_3->setText(tr("1 entry")); }
if (x->pointerCount() > 1) { 
pointerNum = pointerNum.setNum(x->pointerCount(), 10);
textLabel3_3->setText(pointerNum + tr(" entries"));
}

if (x->kbdCount() == 1) { textLabel4_4->setText(tr("1 entry")); }
if (x->kbdCount() > 1) { 
kbdNum = kbdNum.setNum(x->kbdCount(), 10);
textLabel4_4->setText(kbdNum + tr(" entries"));
}




x->mouseIdentBuf[pointerSpinBox->value()] = mouseIdentLineEdit->text();
x->kbdIdentBuf[kbdSpinBox->value()] = kbdIdentLineEdit->text();



}

void kxMain :: addPointer()
{
x->addSection("InputDevice");
x->addInputDriver("mouse");
fillMouseKbd();
pointerSpinBox->setValue(pointerSpinBox->maxValue());
QString num;
num = num.setNum(pointerSpinBox->value(), 10);
mouseIdentLineEdit->setText("Mouse" + num);
}

void kxMain :: addKeyboard()
{
x->addSection("InputDevice");
x->addInputDriver("keyboard");
fillMouseKbd();
kbdSpinBox->setValue(kbdSpinBox->maxValue());
QString num;
num = num.setNum(kbdSpinBox->value(), 10);
kbdIdentLineEdit->setText("Keyboard" + num);
}

void kxMain :: removeMouse()
{
if (x->pointerCount() == 1)
{
QMessageBox::warning(this, "kX Generator", tr("There must be at least one pointer entry."));
return;
}

QString ident = mouseIdentLineEdit->text();

if (x->pointerCount() > 1)
{
x->removeSection("InputDevice", x->pointerTranslate(pointerSpinBox->value()));
fillMouseKbd();
}
int xx = 1;
while (xx <= x->sectionCount("ServerLayout"))
{
x->removeSrvLayComp(xx, "InputDevice", ident);
xx++;
}


}

void kxMain :: removeKeyboard()
{
if (x->kbdCount() == 1)
{
QMessageBox::warning(this, "kX Generator", tr("There must be at least one keyboard entry."));
return;
}

QString ident = kbdIdentLineEdit->text();

if (x->kbdCount() > 1)
{
x->removeSection("InputDevice", x->kbdTranslate(kbdSpinBox->value()));
fillMouseKbd();
}
int xx = 1;



while (xx <= x->sectionCount("ServerLayout"))
{
x->removeSrvLayComp(xx, "InputDevice", ident);
xx++;
}


}

void kxMain :: saveInputDrivers()
{
x->saveValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Driver", 1, comboBox3->text(comboBox3->currentItem()).section(" - ", 0, 0));
x->saveValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Driver", 1, comboBox6->text(comboBox6->currentItem()).section(" - ", 0, 0));
}

void kxMain :: srvInputsPrepare()
{
int a = 0;
QString num;
QString option;
QString option2;

while (a < 1200)
{
num = num.setNum(a, 10);
x->replaceSomething("Screen " + num, "Screen");
a++;
}
a = 1;



//Pointers
while (a <= x->pointerCount())
{
num = x->getSecUniqueNum("InputDevice", x->pointerTranslate(a));
option = "InputDevice \"" + x->getValue("InputDevice", x->pointerTranslate(a), "Identifier", 1) + "\"";
option2 = "InputDevice \"" + num + "-" + x->getValue("InputDevice", x->pointerTranslate(a), "Identifier", 1) + "\"";
x->replaceSomething(option, option2);
a++;
}


//Keyboards
a = 1;
while (a <= x->kbdCount())
{
num = x->getSecUniqueNum("InputDevice", x->kbdTranslate(a));
option = "InputDevice \"" + x->getValue("InputDevice", x->kbdTranslate(a), "Identifier", 1) + "\"";
option2 = "InputDevice \"" + num + "-" + x->getValue("InputDevice", x->kbdTranslate(a), "Identifier", 1) + "\"";
x->replaceSomething(option, option2);
a++;
}

//Screens
int screen = 1;
int srvLay = 1;
QString srvLaySection;
QString scrName;


while (srvLay <= x->sectionCount("ServerLayout"))
{
srvLaySection = x->section("ServerLayout", srvLay);
screen = 1;
while (screen <= x->sectionCount("Screen"))
{
scrName = x->getValue("Screen", screen, "Identifier", 1);
num = x->getSecUniqueNum("Screen",screen);
srvLaySection = srvLaySection.replace(scrName, num + "-" + scrName);
x->replaceSomething(x->section("ServerLayout", srvLay), srvLaySection);
screen++;
}





srvLay++;
}


}

void kxMain :: fillScreen()
{
int a = 0;
modeListBox->clear();
depthListBox->clear();
QString modes;

if(x->getDefaultDepth(scrSpinBox->value()) == "8") { defaultDepthCombo->setCurrentItem(0); }
if(x->getDefaultDepth(scrSpinBox->value()) == "16") { defaultDepthCombo->setCurrentItem(1); }
if(x->getDefaultDepth(scrSpinBox->value()) == "24") { defaultDepthCombo->setCurrentItem(2); }
if(x->getDefaultDepth(scrSpinBox->value()) == "32") { defaultDepthCombo->setCurrentItem(3); }

if (x->haveDepth(scrSpinBox->value(), "8")) { depthListBox->insertItem("8 bpp"); }
if (x->haveDepth(scrSpinBox->value(), "16")) { depthListBox->insertItem("16 bpp"); }
if (x->haveDepth(scrSpinBox->value(), "24")) { depthListBox->insertItem("24 bpp"); }
if (x->haveDepth(scrSpinBox->value(), "32")) { depthListBox->insertItem("32 bpp"); }


depthListBox->setSelected(0, TRUE);


QString num;
int numSecs = x->sectionCount("Screen");
scrSpinBox->setMaxValue(numSecs);
num = num.setNum(numSecs, 10);
if (numSecs == 1) { scrSpinLabel->setText(num + tr(" entry")); }
if (numSecs > 1) { scrSpinLabel->setText(num + tr(" entries")); }


//Identifier

screenIdentEdit->setText(x->getValue("Screen", scrSpinBox->value(), "Identifier", 1));
//Device
a = 0;
while (a < scrDevicesCombo->count())
{
if (x->getValue("Screen", scrSpinBox->value(), "Device", 1) == scrDevicesCombo->text(a)) { scrDevicesCombo->setCurrentItem(a); break; }
a++;
}


//Monitor
a = 0;
while (a < scrMonitorsCombo->count())
{
if (x->getValue("Screen", scrSpinBox->value(), "Monitor", 1) == scrMonitorsCombo->text(a)) { scrMonitorsCombo->setCurrentItem(a); break; }
a++;
}



}

void kxMain :: fillScreenCombos()
{
int a = 1;
scrMonitorsCombo->clear();
while (a <= x->sectionCount("Monitor"))
{
scrMonitorsCombo->insertItem(x->getValue("Monitor", a, "Identifier", 1));
a++;
}

a = 1;
scrDevicesCombo->clear();
while (a <= x->sectionCount("Device"))
{
scrDevicesCombo->insertItem(x->getValue("Device", a, "Identifier", 1));
a++;
}



}

void kxMain :: updateScreenModes()
{
int a = 0;
modeListBox->clear();
QString modes = x->getModes(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0));
while (a > -1)
{
if (modes.section("|", a, a) == "") { break; }
modeListBox->insertItem(modes.section("|", a, a));
a++;
}



modeListBox->setSelected(0, TRUE);
}

void kxMain :: removeScreenMode()
{
x->removeMode(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0), modeListBox->text(modeListBox->currentItem()));
int cnt = modeListBox->currentItem();
updateScreenModes();
if (cnt < modeListBox->count()) { modeListBox->setSelected(cnt, TRUE); }
if (cnt > modeListBox->count()) { modeListBox->setSelected(cnt - 1, TRUE); }
if (cnt == modeListBox->count()) { modeListBox->setSelected(cnt - 1, TRUE); }
}

void kxMain :: addScreenMode()
{
//Checking if mode is already on the list
int a = 0;
while (a <= modeListBox->count())
{
if (modeListBox->text(a) == modeComboBox->text(modeComboBox->currentItem())) 
{
QMessageBox::information(this, "kX Generator", tr("This mode is already on the list."));
return;
}
a++;

}

x->addMode(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0), modeComboBox->text(modeComboBox->currentItem()));
int cnt = modeListBox->currentItem();
updateScreenModes();
modeListBox->setSelected(modeListBox->count() - 1, TRUE);
}

void kxMain :: saveScreenMonitor()
{
x->saveValue("Screen", scrSpinBox->value(), "Monitor", 1, scrMonitorsCombo->text(scrMonitorsCombo->currentItem()));
}

void kxMain :: saveScreenDevice()
{
x->saveValue("Screen", scrSpinBox->value(), "Device", 1, scrDevicesCombo->text(scrDevicesCombo->currentItem()));
}

void kxMain :: removeScreenDepth()
{
bool deleteDef = false;
QString defDepth = x->getDefaultDepth(scrSpinBox->value());
if (depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0) == defDepth) { deleteDef = true; }
x->removeDepth(scrSpinBox->value(), depthListBox->text(depthListBox->currentItem()).section(" bpp", 0, 0));
int cnt = depthListBox->currentItem();
fillScreen();
if (cnt < depthListBox->count()) { depthListBox->setSelected(cnt, TRUE); }
if (cnt > depthListBox->count()) { depthListBox->setSelected(cnt - 1, TRUE); }
if (cnt == depthListBox->count()) { depthListBox->setSelected(cnt - 1, TRUE); }
if (deleteDef) 
{
if (depthListBox->text(depthListBox->currentItem()) == "8 bpp") { defaultDepthCombo->setCurrentItem(0); }
if (depthListBox->text(depthListBox->currentItem()) == "16 bpp") { defaultDepthCombo->setCurrentItem(1); }
if (depthListBox->text(depthListBox->currentItem()) == "24 bpp") { defaultDepthCombo->setCurrentItem(2); }
if (depthListBox->text(depthListBox->currentItem()) == "32 bpp") { defaultDepthCombo->setCurrentItem(3); }
}
}

void kxMain :: saveDefaultDepth()
{
if (x->haveDepth(scrSpinBox->value(), defaultDepthCombo->text(defaultDepthCombo->currentItem()).section(" bpp", 0, 0)))
{
x->saveDefaultDepth(scrSpinBox->value(), defaultDepthCombo->text(defaultDepthCombo->currentItem()).section(" bpp", 0, 0));
}
else
{
if (x->haveDepth(scrSpinBox->value(), "8")) { defaultDepthCombo->setCurrentItem(0); }
if (x->haveDepth(scrSpinBox->value(), "16")) { defaultDepthCombo->setCurrentItem(1); }
if (x->haveDepth(scrSpinBox->value(), "24")) { defaultDepthCombo->setCurrentItem(2); }
if (x->haveDepth(scrSpinBox->value(), "32")) { defaultDepthCombo->setCurrentItem(3); }
}
}

void kxMain :: addDepth()
{
//Checking if mode is already on the list
int a = 0;
while (a <= depthListBox->count())
{
if (depthListBox->text(a) == depthComboBox->text(depthComboBox->currentItem())) 
{
QMessageBox::information(this, "kX Generator", tr("This depth is already on the list."));
return;
}
a++;

}

x->addDepth(scrSpinBox->value(), depthComboBox->text(depthComboBox->currentItem()).section(" bpp", 0, 0));
fillScreen();
depthListBox->setSelected(depthListBox->count() - 1, TRUE);
}

void kxMain :: addLayScreen()
{
QString selected = showSrvLayDialog(3);
if (selected == "NO") { return; }
int a = 0;
while (a <= listBox23->count())
{
if (selected == listBox23->text(a))
{
QMessageBox::information(this, "kX Generator", tr("This screen is already on list.")); return;
}
a++;
}
x->addScreen(listBox16->currentItem() + 1, selected);
fillServerLayoutComponents();
listBox23->setSelected(listBox23->count() - 1, TRUE);
}

void kxMain :: removeSrvScreen()
{
x->removeSrvLayComp(listBox16->currentItem() + 1, "Screen", listBox23->text(listBox23->currentItem()));
int cnt = listBox23->currentItem();
fillServerLayoutComponents();
listBox23->setSelected(cnt, TRUE);
if (cnt == listBox23->count()) { listBox23->setSelected(cnt - 1, TRUE); }
}

void kxMain :: addSrvPointer()
{
QString selected = showSrvLayDialog(1);
if (selected == "NO") { return; }
int a = 0;

while (a <= listBox23_2->count())
{
if (selected == listBox23_2->text(a))
{
QMessageBox::information(this, "kX Generator", tr("This pointer is already on list.")); return;
}
a++;
}
x->addPointer(listBox16->currentItem() + 1, selected);
fillServerLayoutComponents();
listBox23_2->setSelected(listBox23_2->count() - 1, TRUE);
}

void kxMain :: removeSrvPointer()
{
x->removeSrvLayComp(listBox16->currentItem() + 1, "InputDevice", listBox23_2->text(listBox23_2->currentItem()));
int cnt = listBox23_2->currentItem();
fillServerLayoutComponents();
listBox23_2->setSelected(cnt, TRUE);
if (cnt == listBox23_2->count()) { listBox23_2->setSelected(cnt - 1, TRUE); }

}

void kxMain :: addSrvKeyboard()
{
QString selected = showSrvLayDialog(2);
if (selected == "NO") { return; }
int a = 0;

while (a <= listBox23_2_2->count())
{
if (selected == listBox23_2_2->text(a))
{
QMessageBox::information(this, "kX Generator", tr("This keyboard is already on list.")); return;
}
a++;
}
x->addKeyboard(listBox16->currentItem() + 1, selected);
fillServerLayoutComponents();
listBox23_2_2->setSelected(listBox23_2_2->count() - 1, TRUE);

}

void kxMain :: removeSrvKeyboard()
{
x->removeSrvLayComp(listBox16->currentItem() + 1, "InputDevice", listBox23_2_2->text(listBox23_2_2->currentItem()));
int cnt = listBox23_2_2->currentItem();
fillServerLayoutComponents();
listBox23_2_2->setSelected(cnt, TRUE);
if (cnt == listBox23_2_2->count()) { listBox23_2_2->setSelected(cnt - 1, TRUE); }

}

void kxMain :: addScreen()
{
x->addSection("Screen");
QString screenNumber;
screenNumber = screenNumber.setNum(x->sectionCount("Screen"), 10);
x->saveValue("Screen", x->sectionCount("Screen"), "Identifier", 1, "Screen" + screenNumber);
x->saveValue("Screen", x->sectionCount("Screen"), "Device", 1, x->getValue("Device", 1, "Identifier", 1));
x->saveValue("Screen", x->sectionCount("Screen"), "Monitor", 1, x->getValue("Monitor", 1, "Identifier", 1));
fillScreen();
scrSpinBox->setValue(x->sectionCount("Screen"));

}

void kxMain :: removeScreen()
{

if (x->sectionCount("Screen") == 1)
{
QMessageBox::warning(this, "kX Generator", tr("There must be at least one screen entry."));
return;
}
QString ident = screenIdentEdit->text();

if (x->sectionCount("Screen") > 1)
{
x->removeSection("Screen", scrSpinBox->value());
fillScreen();
}

int xx = 1;
while (xx <= x->sectionCount("ServerLayout"))
{
x->removeSrvLayComp(xx, "Screen", ident);
xx++;
}
fillServerLayoutComponents();


}

void kxMain::showGlobalDpmsSettings()
{
DPMSGlobalDialog *globalDPMS = new DPMSGlobalDialog(this, "Global DPMS Dialog", x->returnConfig(), "ServerFlags", 1);
globalDPMS->exec();
x->saveXorg(globalDPMS->returnXorg());
delete globalDPMS;
}

void kxMain::modifyGamma()
{
GammaDialogClass *gammaDialog = new GammaDialogClass (this, "Gamma Dialog", monitorSpinBox->value(), x->returnConfig());
gammaDialog->exec();
x->saveXorg(gammaDialog->returnXorg());
delete gammaDialog;
}



void kxMain :: fillInputIdentBufs()
{


}

void kxMain::resetConfiguration()
{
x->reset();
checkAll();
modulesBox->clear();
modulesPathListBox->clear();
rgbLineEdit->clear();
fontsBox->clear();

srvInputsPrepare();
fillVideocard();
fillMonitor();
fillModules();
fillFiles();
fillServerLayout();
fillMouseKbd();
fillScreenCombos();
fillScreen();
initCheckboxes();

}

void kxMain::modifyServerLayoutDPMS()
{
DPMSGlobalDialog *globalDPMS = new DPMSGlobalDialog(this, "Global DPMS Dialog", x->returnConfig(), "ServerLayout", listBox16->currentItem() + 1);
globalDPMS->exec();
x->saveXorg(globalDPMS->returnXorg());
delete globalDPMS;
}

void kxMain::srvFlagsCheck()
{
if (ServerFlagsContainer->isChecked()) { 
if (x->sectionCount("ServerFlags") == 0) { x->addSection("ServerFlags"); }
}
if (!ServerFlagsContainer->isChecked()) { x->removeSection("ServerFlags", 1); }
}


































#include "kxmain.moc"
