/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "xorg.h"
#include <qfile.h>
#include <iostream.h>
xorgConf :: xorgConf()
{
QFile *xorgFile = new QFile ("/etc/X11/xorg.conf");   /// @todo Change xtest to xorg.conf
xorgFile->open(IO_ReadOnly);
int a = 0;
secUniqueNum = 0;
QString buffer;
QString num;
while (a < 1)
{
num = num.setNum(secUniqueNum, 10);
xorgFile->readLine(buffer, 4096);
buffer = buffer.remove(buffer.section("#", 1, 1));
buffer = buffer.simplifyWhiteSpace().remove("#");
if (buffer.contains("Section \"") > 0 && buffer.contains("SubSection") == 0) { buffer = buffer.append(QChar(10)).append("# " + num); secUniqueNum++;}
xorgConfig = xorgConfig.append(buffer);
xorgConfig = xorgConfig.append(QChar(10));
if (xorgFile->atEnd()) { break; }
}

}

void xorgConf :: saveXorg(QString xorg)
{
xorgConfig = xorg;
}

QString xorgConf :: returnConfig()
{
return xorgConfig;
}

int xorgConf :: sectionCount(QString sectionName)
{
sectionName = sectionName.prepend("Section \"").append("\"");
return xorgConfig.contains(sectionName);
}

QString xorgConf :: section(QString sectionName, int sectionNumber)
{

sectionName = sectionName.prepend("Section \"");
sectionName = sectionName.append("\"");
return xorgConfig.section(sectionName, sectionNumber, sectionNumber).section("EndSection", 0, 0);
}

QString xorgConf :: getValue(QString sectionName, int sectionNumber, QString valueName, int valueNumber)
{
return section(sectionName, sectionNumber).replace(", ", ",").section(valueName, valueNumber, valueNumber + 1).section("\"", 1, 1).section("\n", 0, 0);
}



QString xorgConf :: getOption(QString sectionName, int sectionNumber, QString optionName)
{

return section(sectionName, sectionNumber).section(optionName.prepend("Option \"").append("\""), 1, 1).section("\"", 1, 1);
}

void xorgConf :: removeOption(QString sectionName, int sectionNumber, QString OptionName)
{
QString toRemove = section(sectionName, sectionNumber).section("Option \"" + OptionName + "\"", 1, 1).prepend ("Option \"" + OptionName + "\"").section(QChar(10), 0, 0);
QString toRem2 = section(sectionName, sectionNumber).remove(toRemove + QChar(10));
xorgConfig = xorgConfig.replace(section(sectionName, sectionNumber), toRem2);

}

void xorgConf :: saveValue(QString sectionName, int sectionNumber, QString valueName, int valueNumber, QString newValue)
{
if (section(sectionName, sectionNumber).contains(valueName) > 0)
{
QString buf = getValue(sectionName, sectionNumber, valueName, valueNumber).prepend(valueName + " \"").append("\"");
QString toRep = valueName.append(" \"").append(newValue).append("\"");
QString replacedSection = section(sectionName, sectionNumber).replace(buf, toRep);
xorgConfig = xorgConfig.replace(section(sectionName, sectionNumber), replacedSection);

}


if (section(sectionName, sectionNumber).contains(valueName) == 0)
{

QString df = "Section \"" + sectionName + "\"";
df = df.append(section(sectionName, sectionNumber));
df = df.append(valueName + " \"" + newValue + "\"\n");
df = df.append("EndSection");
QString df2 = "Section \"" + sectionName + "\"" + section(sectionName, sectionNumber) + "EndSection";
xorgConfig = xorgConfig.replace(df2, df);
}


}

void xorgConf :: saveOption(QString sectionName, int sectionNumber, QString valueName, int valueNumber, QString newValue)
{
valueName = valueName.prepend("Option \"").append("\"");

if (section(sectionName, sectionNumber).contains(valueName))
{
QString buf = getValue(sectionName, sectionNumber, valueName, valueNumber).prepend(valueName + " \"").append("\"");
QString toRep = valueName.append(" \"").append(newValue).append("\"");
QString replacedSection = section(sectionName, sectionNumber).replace(buf, toRep);
xorgConfig = xorgConfig.replace(section(sectionName, sectionNumber), replacedSection);
}
if (!section(sectionName, sectionNumber).contains(valueName))
{
QString df = "Section \"" + sectionName + "\"";
df = df.append(section(sectionName, sectionNumber));
df = df.append(valueName + " \"" + newValue + "\"\n");
df = df.append("EndSection");
QString df2 = "Section \"" + sectionName + "\"" + section(sectionName, sectionNumber) + "EndSection";
xorgConfig = xorgConfig.replace(df2, df);
}

}

void xorgConf ::removeSection(QString sectionName, int sectionNumber)
{
xorgConfig.replace(section(sectionName, sectionNumber), section(sectionName, sectionNumber).simplifyWhiteSpace());
xorgConfig.remove(section(sectionName, sectionNumber).simplifyWhiteSpace());
QString bad = "Section \"" + sectionName + "\"EndSection";
xorgConfig.remove(bad);
}

void xorgConf :: addSection (QString sectionName)
{
xorgConfig = xorgConfig.append("\nSection \"" + sectionName + "\"\n");
QString secNum;
secNum = secNum.setNum(secUniqueNum);


xorgConfig = xorgConfig.append("# " + secNum + "\nEndSection\n");
secUniqueNum++;
}

void xorgConf :: addModule (QString moduleName)
{
xorgConfig = xorgConfig.replace("Section \"Module\"", "Section \"Module\"\nLoad \"" + moduleName + "\"");
}

void xorgConf :: removeModule (QString moduleName)
{
xorgConfig = xorgConfig.remove("Load \"" + moduleName + "\"\n");
}

QString xorgConf :: getSrvLayScreens(int sectionNumber)
{
QString scr1;
QString toRet = "";
int a = 1;
while (a > -1)
{
scr1 =  section("ServerLayout", sectionNumber).section("Screen", a, a + 1).section("\"", 1, 1);
if (scr1 == "") { break; }
toRet = toRet.append(scr1 + "|");
a = a + 2;
}
return toRet;
}

int xorgConf :: kbdCount()
{
return xorgConfig.contains("Driver \"kbd\"") + xorgConfig.contains("Driver \"keyboard\"");
}

int xorgConf :: pointerCount()
{
return sectionCount("InputDevice") - kbdCount();
}

int xorgConf :: kbdTranslate(int sectionNum)
{
int secCnt = 0;
int x = 0;
while (secCnt <= sectionCount("InputDevice"))
{
if (isKeyboard(x)) { secCnt++; }
if (secCnt == sectionNum) { break; }
x++;
}
return x;
}

int xorgConf :: pointerTranslate(int sectionNum)
{
int secCnt = 0;
int x = 0;
while (secCnt <= sectionCount("InputDevice"))
{
if (isPointer(x)) { secCnt++; }
if (secCnt == sectionNum) { break; }
x++;
}
return x;
}

bool xorgConf :: isKeyboard(int sectionNum)
{
if (section("InputDevice", sectionNum).contains("Driver \"kbd\"") > 0 || section("InputDevice", sectionNum).contains("Driver \"keyboard\"") > 0) { return true; }
return false;
}

bool xorgConf :: isPointer (int sectionNum)
{
if (section("InputDevice", sectionNum).contains("Driver")) {
if (section("InputDevice", sectionNum).contains("Driver \"kbd\"") == 0 && section("InputDevice", sectionNum).contains("Driver \"keyboard\"") == 0) { return true; }
}
return false;
}

QString xorgConf :: getMouseList()
{
QString mouseList = "";
int a = 1;

while (a <= sectionCount("InputDevice"))
{
if (isPointer(a)) { mouseList = mouseList.append(getValue("InputDevice", a, "Identifier", 1) + "|"); }
a++;
}


return mouseList;
}

QString xorgConf :: getKeyboardList()
{
QString keyboardList = "";
int a = 1;

while (a <= sectionCount("InputDevice"))
{
if (isKeyboard(a)) { keyboardList = keyboardList.append(getValue("InputDevice", a, "Identifier", 1) + "|"); }
a++;
}

return keyboardList;
}

void xorgConf :: removeValue(QString sectionName, int sectionNum, QString valueName, int valueNum)
{
xorgConfig = xorgConfig.remove(section(sectionName, sectionNum).section(valueName, valueNum, valueNum).section(QChar(10), 0, 1).prepend(valueName).append(QChar(10)));
}

bool xorgConf :: valExists(QString sectionName, int sectionNumber, QString valueName)
{
if (section(sectionName, sectionNumber).contains(valueName) > 0) { return true; }
return false;
}

void xorgConf :: addInputDriver(QString drvName)
{
QString num;
num = num.setNum(secUniqueNum - 1, 10);
num = num.prepend("# ");
xorgConfig = xorgConfig.replace(num, num + "\nDriver \"" + drvName + "\"\n");
}

void xorgConf :: replaceSomething(QString rep1, QString rep2)
{
xorgConfig = xorgConfig.replace(rep1, rep2);
}

bool xorgConf :: haveDepth(int sectionNum, QString depth)
{
if (section("Screen", sectionNum).contains("\nDepth " + depth) > 0) { return true; }
return false;
}

QString xorgConf :: getDefaultDepth(int sectionNum)
{
return section("Screen", sectionNum).section("DefaultDepth ", 1, 1).section("\n", 0, 0);
}

QString xorgConf :: getModes(int sectionNum, QString depth)
{
return section("Screen", sectionNum).section("Depth " + depth + "\nModes ", 1, 1).section(QChar(10), 0, 0).remove("\"").replace(" ", "|").append("|");
}

void xorgConf :: removeMode (int sectionNum, QString depth, QString mode)
{
QString sf = section("Screen", sectionNum);
QString section = sf.section("Depth " + depth + "\nModes", 1, 1).section(QChar(10), 0, 0).prepend("Depth " + depth + "\nModes");
QString toReplace = section;
toReplace = toReplace.remove("\"" + mode + "\" ");
toReplace = toReplace.remove("\"" + mode + "\"");

toReplace = toReplace.replace("\n", "|");
toReplace = toReplace.simplifyWhiteSpace();
toReplace = toReplace.replace("|", "\n");
sf = sf.replace(QChar(10), "/");
sf = sf.simplifyWhiteSpace();
sf = sf.replace("/", QChar(10));
sf = sf.replace(section, toReplace);
toReplace = this->section("Screen", sectionNum);
xorgConfig = xorgConfig.replace(toReplace, sf);


}

void xorgConf :: addMode(int sectionNum, QString depth, QString mode)
{
QString sf = section("Screen", sectionNum);
QString section = sf.section("Depth " + depth + "\nModes", 1, 1).section(QChar(10), 0, 0).prepend("Depth " + depth + "\nModes");
QString toReplace = section;
toReplace = toReplace.append(" \"" + mode + "\"");

toReplace = toReplace.replace("\n", "|");
toReplace = toReplace.simplifyWhiteSpace();
toReplace = toReplace.replace("|", "\n");

sf = sf.replace(QChar(10), "/");
sf = sf.simplifyWhiteSpace();
sf = sf.replace("/", QChar(10));
sf = sf.replace(section, toReplace);
toReplace = this->section("Screen", sectionNum);
xorgConfig = xorgConfig.replace(toReplace, sf);

}

void xorgConf :: removeDepth(int sectionNum, QString depth)
{
QString sf = section("Screen", sectionNum);
QString section = sf.section("Depth " + depth + "\nModes", 1, 1).section(QChar(10), 0, 0).prepend("Depth " + depth + "\nModes");
section = section.prepend("SubSection \"Display\"\n");
section = section.append("\nEndSubSection");
QString toRemove = sf;
toRemove = toRemove.remove(section);
xorgConfig = xorgConfig.replace(sf, toRemove);

}

void xorgConf :: saveDefaultDepth(int sectionNum, QString depth)
{
QString sec = section("Screen", sectionNum);
QString before = "DefaultDepth " + getDefaultDepth(sectionNum);
QString after = "DefaultDepth " + depth;
sec = sec.replace(before, after);
xorgConfig = xorgConfig.replace(section("Screen", sectionNum), sec);
}

void xorgConf :: addDepth(int sectionNum, QString depth)
{
QString sf = section("Screen", sectionNum);
QString buf = sf;
QString toReplace = sf.append("SubSection \"Display\"\nDepth " + depth + "\nModes \nEndSubSection\n");

xorgConfig = xorgConfig.replace(buf, toReplace);
}

void xorgConf :: addScreen(int sectionNum, QString name)
{
int a = 1;
QString num;
while (a <= sectionCount("Screen"))
{
if (getValue("Screen", a, "Identifier", 1) == name) { break; }
a++;
}
num = num.setNum(a, 10);
QString before = section("ServerLayout", sectionNum);
QString after = section("ServerLayout", sectionNum).append("Screen \"" + num + "-" + name + "\"\n");
xorgConfig = xorgConfig.replace(before, after);
}

void xorgConf :: removeSrvLayComp(int sectionNum, QString name, QString value)
{
if (section("ServerLayout", sectionNum).contains(value) == 0) { return; }

name = name + " ";
QString sec = section("ServerLayout", sectionNum);
QString toRet = "NO";
int a = 0;
while (a > -1)
{
if (sec.section(QChar(10), a, a) == "EndSection") { break; }

if (sec.section(QChar(10), a, a).contains(name) > 0 && sec.section(QChar(10), a, a).contains(value) > 0)
{ 
toRet = sec.section(QChar(10), a, a);
break;
}
a++;
}





if (toRet != "NO")
{
sec = sec.remove(toRet);
}

xorgConfig = xorgConfig.replace(section("ServerLayout", sectionNum), sec);
}

void xorgConf :: addPointer (int sectionNum, QString name)
{
int a = 1;
QString num;
while (a <= sectionCount("InputDevice"))
{
if (getValue("InputDevice", pointerTranslate(a), "Identifier", 1) == name) { break; }
a++;
}
num = num.setNum(pointerTranslate(a), 10);
QString before = section("ServerLayout", sectionNum);
QString after = section("ServerLayout", sectionNum).append("InputDevice \"" + num + "-" + name + "\"\n");
xorgConfig = xorgConfig.replace(before, after);
}

void xorgConf :: addKeyboard(int sectionNum, QString name)
{
int a = 1;
QString num;
while (a <= sectionCount("InputDevice"))
{
if (getValue("InputDevice", kbdTranslate(a), "Identifier", 1) == name) { break; }
a++;
}
num = num.setNum(kbdTranslate(a), 10);
QString before = section("ServerLayout", sectionNum);
QString after = section("ServerLayout", sectionNum).append("InputDevice \"" + num + "-" + name + "\"\n");
xorgConfig = xorgConfig.replace(before, after);
}

void xorgConf :: saveValNoBr(QString sectionName, int sectionNumber, QString valueName, int valueNumber, QString newValue)
{
if (section(sectionName, sectionNumber).contains(valueName) > 0)
{
QString buf = getValue(sectionName, sectionNumber, valueName, valueNumber).prepend(valueName + " \"").append("\"");
QString toRep = valueName.append(" ").append(newValue);
QString replacedSection = section(sectionName, sectionNumber).replace(buf, toRep);
xorgConfig = xorgConfig.replace(section(sectionName, sectionNumber), replacedSection);

}


if (section(sectionName, sectionNumber).contains(valueName) == 0)
{
QString df = "Section \"" + sectionName + "\"";
df = df.append(section(sectionName, sectionNumber));
df = df.append(valueName + newValue + "\n");
df = df.append("EndSection");
QString df2 = "Section \"" + sectionName + "\"" + section(sectionName, sectionNumber) + "EndSection";
xorgConfig = xorgConfig.replace(df2, df);
}


}

QString xorgConf :: getGamma(int sectionNum)
{
return section("Monitor", sectionNum).section("Gamma ", 1, 1).section(QChar(10), 0, 0);
}

void xorgConf :: removeGamma(int sectionNum)
{
QString oldSec = section("Monitor", sectionNum);
QString newSec = section("Monitor", sectionNum).remove(section("Monitor", sectionNum).section("Gamma ", 1, 1).section(QChar(10), 0, 0).prepend("Gamma "));
xorgConfig = xorgConfig.replace(oldSec, newSec);
}

void xorgConf :: saveGamma(int sectionNum, int red, int green, int blue)
{
float redF = red;
redF = redF / 10;
float greenF = green;
greenF = greenF / 10;
float blueF = blue;
blueF = blueF / 10;
QString redS;
redS = redS.setNum(redF, 'f', 1);
QString greenS;
greenS = greenS.setNum(greenF, 'f', 1);
QString blueS;
blueS = blueS.setNum(blueF, 'f', 1);


removeGamma(sectionNum);


QString oldSec = section("Monitor", sectionNum);
QString newSec = section("Monitor", sectionNum).append("Gamma " + redS + " " + greenS + " " + blueS + QChar(10));
xorgConfig = xorgConfig.replace(oldSec, newSec);
}

void xorgConf :: saveGamma(int sectionNum, int gamma)
{
float gam = gamma;
gam = gam / 10;
QString num;
num = num.setNum(gam, 'f', 1);
removeGamma(sectionNum);
QString oldSec = section("Monitor", sectionNum);
QString newSec = section("Monitor", sectionNum).append("Gamma " + num + QChar(10));
xorgConfig = xorgConfig.replace(oldSec, newSec);
}

bool xorgConf :: checkOption(QString sectionName, int sectionNum, QString name)
{
if (section(sectionName, sectionNum).contains(name) > 0)
{
cout << getValue(sectionName, sectionNum, name, 1).lower() << endl;
if (getOption(sectionName, sectionNum, name).lower() == "1") { return true; }
if (getOption(sectionName, sectionNum, name).lower() == "on") { return true; }
if (getOption(sectionName, sectionNum, name).lower() == "true") { return true; }
if (getOption(sectionName, sectionNum, name).lower() == "yes") { return true; }
}
return false;
}
int xorgConf :: returnSecNum()
{
return secUniqueNum;
}

void xorgConf :: reset()
{
QString newXorg =
"Section \"ServerLayout\"\n"
"Identifier \"Layout1\"\n"
"Screen \"Screen1\"\n"
"InputDevice \"Keyboard1\"\n"
"InputDevice \"Mouse1\"\n"
"EndSection\n"
"\n"
"Section \"Module\"\n"
"EndSection\n"
"\n"
"Section \"InputDevice\"\n"
"   Identifier \"Mouse1\"\n"
"   Driver \"mouse\"\n"
"   Option \"Protocol\" \"auto\"\n"
"EndSection\n"
"\n"
"Section \"InputDevice\"\n"
"   Identifier \"Keyboard1\"\n"
"   Driver \"kbd\"\n"
"   Option \"XkbLayout\" \"en_US\"\n"
"EndSection\n"
"\n"
"Section \"Screen\"\n"
"   Identifier \"Screen1\"\n"
"   Device \"Device1\"\n"
"   Monitor \"Monitor1\"\n"
"   DefaultDepth 8\n"
"SubSection \"Display\"\n"
"Depth 8\n"
"Modes \"640x480\" \"800x600\"\n"
"EndSubSection\n"
"   EndSection\n"
"\n"
"Section \"Device\"\n"
"   Identifier \"Device1\"\n"
"   Driver \"nv\"\n"
"   VendorName \"Unknown\"\n"
"EndSection\n"
"\n"
"Section \"Monitor\"\n"
"   Identifier \"Monitor1\"\n"
"   VendorName \"Unknown\"\n"
"   ModelName \"Unknown\"\n"
"EndSection\n"
"\n";

newXorg = newXorg.replace("\n", "|");
xorgConfig = newXorg.simplifyWhiteSpace().replace("|", "\n");
}

QString xorgConf :: getSecUniqueNum(QString sectionName, int sectionNum)
{
return section(sectionName, sectionNum).section("# ", 1, 1).section("\n", 0, 0);

}
